/*variable specification */

unsigned int	scstp,scrte,ted[20],aa,sec,osec,tmdt,diff;
int	inflg,rxque[20],dcount;
int	cmflg,cmmsg,crptr,ctxpi,ctxpq,cmbcr,cmctl;
int	x,y,z,told,m,n,a,b,c;
unsigned int	bit,byte,key,upkey,keyold,kycnt,keylev,disl,men[12],sumck;
unsigned char	keyary[20],mem[200],datac,secnds,oldmtr;
long secs;
/*memory emulation labels*/
unsigned char	chnl=0x10,rcfrq=0x12,txfrq=0x15,rcflg=0x18,txflg=0x19;
unsigned char	rdflg=0x1A,anfrq=0x1B,anmtr=0x1C,clock=0x1D,clock0=0x20;
unsigned char	scptr=0x21,kyflg=0x22,keycd=0x23,kytmr=0x24,fnflg=0x25;
unsigned char	funcd=0x26,dsflg=0x27,auflg=0x28,portc=0x29,pgflg=0x2A;
unsigned char	pgdgt=0x2B,sqlch=0x2C,adflg=0x2D,confg=0x2E,bank=0x2F,work=0x30;
unsigned char	work1=0x31,work2=0x32,work3=0x33,work4=0x34,work5=0x35,temp=0x36;
/*labels*/
/*opcodes*/
unsigned char	reset=0x80,rcall=0x81,rview=0x82,rstor=0x83,store=0x84,ldfrq=0x85;
unsigned char	ldclk=0x86,lddte=0x87,emfrq=0x88,stclc=0x89,smode=0x8A,tsbfl=0x8B;
unsigned char	tvtfl=0x8C,tattn=0x8D,txmtp=0x8E,tblnk=0x8F,scscr=0x90,sfscr=0x91;
unsigned char	clari=0x92,rqxmt=0x93,chstp=0x94,fqstp=0x95,gttme=0x96,gtdte=0x97;
unsigned char	sview=0x98,stscn=0x99,txemf=0x9A,chscn=0x9B,fqscn=0x9C,spscn=0x9D;
unsigned char	scnps=0x9E,pwmtr=0x9F,scnpn=0xA0,ldtmr=0xA1,tmrgl=0xA2,gttmr=0xA3;
unsigned char	gttof=0xA4,incom=0xA5,prmup=0xA6,pchup=0xA7,obeep=0xA8,scont=0xA9;
unsigned char	swtfr=0xAA,lkchn=0xAB,ulchn=0xAC;

/*bit labels*/
unsigned char	chv=0;
unsigned char chl;
unsigned char     att=3;
unsigned char     voc=4;
unsigned char     lsb=5;
unsigned char	pci=6;
unsigned char     ssb=7;
unsigned char	tn=1;
unsigned char	tmp=2;
unsigned char	nb=4;
unsigned char	scn=5;
unsigned char	icm=6;
unsigned char	set=7;
unsigned char	sr=5;
unsigned char	tmr=7;
unsigned char	tpl=5;
char	dnky=9,upky=8;
int t,d,co,a,c,x,y,word,stat,tm;
char trigger,ready,bcount,yy,xx,ty,tx;
int data[40][40],b,rcount,lp1;
int line[20];
unsigned char	brak,xc,yc,txque[40][40];
int	rxtx,inte,disc,lcon,mcon,lstt,mstt,prt,ivln;
char	icont;

/*function definition*/
#include <dos.h>
#include <stdio.h>
#include <ctype.h>

interrupt comrx()
{
		d=inportb(disc)&6;
		if(d<4) if(brak==1) d=2;
		switch (d) {
      	case 6: stat=inportb(lstt);
						if((stat&0x10)==0x10) {
							trigger=1;
							yy++;
                  }
						break;
			case 4:	stat=inportb(lstt);
						word=inportb(rxtx);
               	if(trigger==1) {
							if((word&0x8f)==0x80) {
								co=3;
                        break;
							}
							if((word&0x0f)==0) break;
							bcount=(word&0x0f)+1;
							trigger=0;
                     data[++xx][yy]=word;
							break;
						}
						if(bcount==0) {
							if((word&0x0f)==0) break;
							bcount=(word&0x0f)+2;
							yy++;
							xx=0;
						}
						if((stat&1)!=1) break;
						data[++xx][yy]=word;
						bcount--;
						if(bcount<=0) {
							ready=1;
							bcount=0;
						}
					   break;
			case 2:	if(brak==0) {
							trigger=2;
							break;
						}
						if(brak==1) brak=2;
                  if(b>0) {
							if(++yc>=ty) {
		                  brak=0;
								ty=1;
								yc=1;
								xc=1;
								b=0;
								outportb(rxtx,0);
								break;
							}
							b=0;
						}
						if(xc==1) {
							rcount=(txque[xc][yc]&0x0f)+2;
							if(ty>1) {
								if(yc==1) {
									if(brak!=4) {
										outportb(rxtx,0);
										brak=4;
										break;
									}
								}
							}
						}
						outportb(rxtx,txque[xc++][yc]);
						if(xc>rcount) {
							b++;
							xc=1;
						}
						break;

			case 0: d=inportb(mstt);
			}
		outportb(mcon,0x0f);
		outportb(0x20,0x20);
		}


main()
{

   setup();
	distm();
	dsetting();
	key=1;
	for(;;) {
	sec=(time(&secs));
	if((sec-osec)>=1) distm();
	if(ready==1) dump();
	if(brak==3) send();
	if(disl==0) menu();
	if(kbhit()) menu();
        }
}
menu()
{
 	kytmr=told;
	keyold=key;
	if(disl>=1) {
		key=bioskey(0);
		if(ty>1) return;
	}
	if(disl==0) {
		menu1();
		disl=1;
		key=0;
		cursoroff();
		}
	upkey=key;
	key=key & 0xFF;
	key=toupper(key);
	men[disl]=key;
	switch(men[1]) {
		case 'A': fun1a();
		break;
		case 'B': fun1b();
		break;
		case 'C': fun1c();
		break;
		case 'D': fun1d();
		break;
		case 'E': fun1e();
		break;
		case 'F': fun1f();
		break;
		case 'G': fun1g();
		break;
		case 'H': fun1h();
		break;
		case 'I': fun1i();
		break;
		case 'J': fun1j();
		break;
		case 0:
 			switch(upkey>>8) {
				case 72:
					mem[work]=upky;
					comqu(work,clari,1);
			break;
				case 80:
					mem[work]=dnky;
					comqu(work,clari,1);
					break;
				}
	}
}
fun1a()
{
	if(disl==1) {
		gotoxy(3,21);
		printf("Enter Channel ");
		gotoxy(13,2);
     	printf("    \b");
		disl=2;
		cursoron();
		return;
		}
	if(key==13) {
		for(x=2;x>0;x--) mem[chnl+x-1]=0;
		inbcd(chnl);
		disl=0;
		dsetting();
		kycnt=0;
		gotoxy(1,20);
		delline();
      comqu(chnl,rcall,2);
		return;
		}
	if(key==8) {
		if(kycnt>=1) {
			kycnt--;
			dchar();
			}
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>3) return;
		kycnt++;
		keyary[kycnt]=keycd;
		dchar();
		}

}
fun1b()
{

	if(disl==1) {
		gotoxy(3,21);
		printf("Enter new frequency\n ");
		printf(" Use the 'UP' or 'DOWN' arrows to step through frequency");
		gotoxy(19,3);
		disl=2;
		y=0;
		cursoron();
		return;
		}
	if(key==8) {
		if(kycnt>=1) {
			kycnt--;
			dchar();
		}
	}
	if(key==13) {
   	if(disl==2) {
			for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
  			inbcd(rcfrq);
			 gotoxy(18,4);
			 disl=3;
			 kycnt=0;
			 return;
		}
		for(x=3;x>0;x--) mem[txfrq+x-1]=0;
  		inbcd(txfrq);
		if(mem[txfrq+2]==0) {
			if(mem[txfrq+1]<0x50) for(x=3;x>0;x--) mem[txfrq+x-1]=mem[rcfrq+x-1];
		}
		sflg(chv,rcflg);
		disl=0;
		kycnt=0;
		cflg(1,dsflg);
		gotoxy(1,20);
		delline();
      comqu(rcfrq,ldfrq,7);
		return;
	}
		if(key==0) {
			if(ty>=3) return;
 			switch(upkey>>8) {
				case 72:
					mem[work]=upky;
					kycnt=0;
					mem[chnl]=0;
					mem[chnl+1]=0;
					for(x=3;x>0;x--) mem[txfrq+x-1]=0;
					sflg(chv,rcflg);
	   		   comqu(work,fqstp,1);
					break;
				case 80:
					mem[work]=dnky;
						kycnt=0;
					for(x=3;x>0;x--) mem[txfrq+x-1]=0;
					sflg(chv,rcflg);
	   		   comqu(work,fqstp,1);
					mem[chnl]=0;
					mem[chnl+1]=0;
					break;
			}
		sflg(1,dsflg);
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt==0) {
			if(disl==2){
				gotoxy(13,2);
				printf("     ");
				gotoxy(13,3);
				printf("       ");
				gotoxy(13,4);
				printf("       ");
				gotoxy(18,3);
			}
		}
		if(kycnt>5) return;
		kycnt++;
		keyary[kycnt]=keycd;
		dchar();
		}
        else return;


}
fun1c()
{
	if(disl==1) {
		menu1c();
        	disl=2;
		return;
		}
	switch(men[2]) {
		case 'A': funca();
		break;
		case 'B': funcb();
		break;
		case 'C': funcc();
		break;
		case 'D': funcdd();
		break;
		case 'E': funce();
		break;
		case 'F': funcf();
		break;
		case 'G': funcg();
		break;
		}
	if(key==27) disl=0;

}
funca()
{
	if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Enter Scan Bank to program ");
		disl=3;
		cursoron();
		keylev=3;
		return;
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		if(disl==4) if(kycnt==0) printf("     \b\b\b\b\b");
		printf("%d",keycd);
		if(disl==3) {
			printf("\b");
			kycnt=0;
		}
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
	if(disl==4) {
		switch(key) {
			case 0:
 			switch(upkey>>8) {
				case 72:
					mem[bank]++;
					if(((mem[bank]+1)&0x0F)>10) {
						mem[bank]-- ;
						if(mem[bank]<0x90) mem[bank]=(mem[bank]+0x10)&0xF0;
					}
  					if(kycnt>0) {
						mem[chnl]=0;
						mem[chnl+1]=0;
						inbcd(chnl);
						kycnt=0;
					}
					comqu(bank,sview,1);
					comqu(chnl,stscn,3);
					mem[rcfrq]=mem[bank];
					mem[chnl]=0;
					mem[chnl+1]=0;
					break;
				case 80:
					mem[bank]--;
					if((mem[bank]&0x0F)>9) {
						mem[bank]++;
						if((mem[bank]&0xF0)>0) mem[bank]=mem[bank]-0x10+9;
					}
  					if(kycnt>0) {
						mem[chnl]=0;
						mem[chnl+1]=0;
						inbcd(chnl);
						kycnt=0;
					}
					comqu(bank,sview,1);
					comqu(chnl,stscn,3);
					mem[rcfrq]=mem[bank];
					mem[chnl]=0;
					mem[chnl+1]=0;
					break;
         	case 75:
					if((mem[bank]&0xF0)>0) mem[bank]=(mem[bank]-0x10)&0xF0;
  					if(kycnt>0) {
						mem[chnl]=0;
						mem[chnl+1]=0;
						inbcd(chnl);
						kycnt=0;
					}
					comqu(bank,sview,1);
					comqu(chnl,stscn,3);
					mem[rcfrq]=mem[bank];
					mem[chnl]=0;
					mem[chnl+1]=0;
					break;
				case 77:
					if(mem[bank]<0x90) mem[bank]=(mem[bank]+0x10)&0xF0;
  					if(kycnt>0) {
						mem[chnl]=0;
						mem[chnl+1]=0;
						inbcd(chnl);
						kycnt=0;
					}
					comqu(bank,sview,1);
					comqu(chnl,stscn,3);
					mem[rcfrq]=mem[bank];
					mem[chnl]=0;
					mem[chnl+1]=0;
					break;
				}
            momenuc();
				return;
			case 8:
				if(kycnt>0) {
					kycnt--;
					printf("\b \b");
				}
				break;
			case 13:
  					if(kycnt>0) {
						mem[chnl]=0;
						mem[chnl+1]=0;
						inbcd(chnl);
						kycnt=0;
				  		comqu(chnl,stscn,3);
					}
				gotoxy(1,22);
				printf("                                 \n");
				printf("                                                  \n");
				printf("                       ");
				disl=0;
				kycnt=0;
				break;
			}
			return;
	}
	if(key==13) {
          		mem[bank]=keycd<<4;
		         comqu(bank,sview,1);
				   gotoxy(13,15);
				   printf("Scan Bank                    Channel ");
				   disl=4;
					gotoxy(1,22);
					printf("Use the -> and <- to change banks\n");
					printf("Use the 'UP' and 'DOWN' arrows to change scan bins\n");
					printf("Press 'ENTER' when done");
					momenuc();
				   kycnt=0;
				   return;
					}
}
funcb()
{
	if(disl==2) {
		menucb();
		disl=3;
		return;
		}
	switch(men[3]) {
		case 'A': funcba();
		break;
		case 'B': funcbb();
		break;
		case 'C': funcbc();
		break;
		}
	if(key==27) disl=0;

		return;

}

funcba()
{
	if(disl==3) {
		menuc();
		gotoxy(13,15);
		printf("On time     :  ");
		gotoxy(13,16);
		printf("Off time    :  ");
		gotoxy(23,15);
		keylev=3;
		disl=4;
		cursoron();
		return;
		}
		if(key==8) {
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				if(kycnt==1) printf("\b :\b\b");
				}
				}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		printf("%d",keycd);
		if(kycnt==1) printf(":");
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
	if(disl==5) {
		if(key==13) {
   			mem[work]=0;
				mem[work1]=0;
				inbcd(work);
				comqu(work,ldtmr,4);
				disl=0;
				kycnt=0;
				}
		return;
		}
	if(key==13) {
				mem[work2]=0;
				mem[work3]=0;
            inbcd(work2);
				disl=5;
				keylev=3;
				kycnt=0;
				gotoxy(23,16);
				return;
				}

}
funcbb()
{
	if(disl==3) {
		menuc();
		gotoxy(13,15);
		printf("Enter desired turn on channel ");
		disl=4;
		keylev=3;
		cursoron();
      return;
		}
		if(key==8) {
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				}
				}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		printf("%d",keycd);
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
		if(key==13) {
   			mem[work]=0;
				mem[work1]=0;
      		inbcd(work);
		       comqu(work,pchup,2);
				disl=0;
				kycnt=0;
				}

}
funcbc()
{
	if(disl==3) {
		keylev=5;
		momenu();
		modis();
		gotoxy(9,14);
		printf("Enter on frequency ");
		gotoxy(25,15);
		disl=4;
		cursoron();
		return;
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		if (kycnt==0) printf("        \b\b\b\b\b\b\b\b");
		printf("%d",keycd);
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
	if(disl==4) {
		switch(key) {
			case 0:
 			switch(upkey>>8) {
         	case 72:
					if(wherey()==16) {
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[txfrq+x-1]=0;
							inbcd(txfrq);
							}
						gotoxy(25,15);
						keylev=5;
						kycnt=0;
						return;
						}
						return;
         	case 80:
					if(wherey()==15) {
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
							inbcd(rcfrq);
							}
						gotoxy(25,16);
						keylev=5;
						kycnt=0;
						return;
				default:
					return;
					}
			}
			case 'A':
   			if(flgs(pci,rcflg)==1) {
					if(flgs(ssb,rcflg)==1) {
							cflg(ssb,rcflg);
							cflg(pci,rcflg);
							modis();
							return;
							}
					else sflg(ssb,rcflg);
					modis();
					return;
					}
				else {
				if(flgs(ssb,rcflg)==1) {
							sflg(pci,rcflg);
							cflg(ssb,rcflg);
							modis();
							return;
							}
				else sflg(ssb,rcflg);
                }
				break;
			case 'B':
				tflg(voc,rcflg);
				break;
			case 'D':
				tflg(att,rcflg);
				break;
			case 'C':
				tflg(lsb,rcflg);
				break;
			case 13:
		  		comqu(rcfrq,prmup,7);
				disl=0;
				kycnt=0;
				gotoxy(1,20);
				delline();
				return;
			case 8:
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				}
			return;
		}
		modis();
		return;
	}
}

funcc()
{
		if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Enter desired channel to program ");
		disl=3;
		keylev=1;
		gotoxy,(13,14);
		cursoron();
		return;
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		if (kycnt==0) printf("        \b\b\b\b\b\b\b\b");
		printf("%d",keycd);
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
	if(disl==4) {
		switch(key) {
			case 0:
 			switch(upkey>>8) {
				case 77:
	         x=wherey();
				switch(x) {
					case 14: break;
					case 15:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
							inbcd(rcfrq);
							}
						gotoxy(25,14);
						keylev=1;
						kycnt=0;
						break;
					case 16:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[txfrq+x-1]=0;
							inbcd(txfrq);
							}
						gotoxy(25,15);
						keylev=5;
						kycnt=0;
						break;
						}
				mem[work]=mem[chnl];
				mem[work]++;
				if(((mem[work]&0x0F)+1)>10) {
				mem[work]-- ;
				if(mem[work]<0x90) mem[work]=(mem[work]+0x10)&0xF0;
				}
				comqu(work,rview,1);
   			comqu(chnl,store,9);
				mem[chnl]=mem[work];
				for(t=1;t<8;t++) mem[chnl+t]=0;
         	sflg(pci,rcflg);
				modis();

				return;
				case 75:
	         x=wherey();
				switch(x) {
					case 14: break;
					case 15:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
							inbcd(rcfrq);
							}
						gotoxy(25,14);
						keylev=1;
						kycnt=0;
						break;
					case 16:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[txfrq+x-1]=0;
							inbcd(txfrq);
							}
						gotoxy(25,15);
						keylev=5;
						kycnt=0;
						break;
						}
				mem[work]=mem[chnl];
				mem[work]--;
				if((mem[work]&0x0F)>9) {
				mem[work]++;
				if((mem[work]&0xF0)>0) mem[work]=mem[work]-0x10+9;
				}
				comqu(work,rview,1);
				comqu(chnl,store,9);
				mem[chnl]=mem[work];
				for(t=1;t<8;t++) mem[chnl+t]=0;
         	sflg(pci,rcflg);
				modis();
				return;
			  	case 83:
      	   	sflg(chv,rcflg);
					for(t=1;t<8;t++) mem[chnl+t]=0;
         	   comqu(chnl,stclc,2);
         		sflg(pci,rcflg);
               modis();
					return;
         	case 72:
            x=wherey();
				switch(x) {
					case 14: return;
					case 15:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
							inbcd(rcfrq);
							}
						gotoxy(25,14);
						keylev=1;
						kycnt=0;
						return;
					case 16:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[txfrq+x-1]=0;
							inbcd(txfrq);
							}
						gotoxy(25,15);
						keylev=5;
						kycnt=0;
						return;
						}
         	case 80:
            x=wherey();
				switch(x) {
					case 14:
						if(kycnt>0) {
							for(t=1;t<8;t++) mem[chnl+t]=0;
         				sflg(pci,rcflg);
							inbcd(chnl);
							modis();
							comqu(chnl,rview,1);
							}
						gotoxy(25,15);
						keylev=5;
						kycnt=0;
						return;
					case 15:
						if(kycnt>0) {
							for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
							inbcd(rcfrq);
							}
						gotoxy(25,16);
						keylev=5;
						kycnt=0;
						return;
					case 16: return;
            	}
				return;
				}
			break;
			case 'A':
   			if(flgs(pci,rcflg)==1) {
					if(flgs(ssb,rcflg)==1) {
							cflg(ssb,rcflg);
							cflg(pci,rcflg);
							modis2();
							return;
							}
					else sflg(ssb,rcflg);
					modis2();
					return;
					}
				else {
				if(flgs(ssb,rcflg)==1) {
							sflg(pci,rcflg);
							cflg(ssb,rcflg);
							modis2();
							return;
							}
				else sflg(ssb,rcflg);
                }
				break;
			case 'B':
				tflg(voc,rcflg);
				break;
			case 'D':
				tflg(att,rcflg);
				break;
			case 'C':
				tflg(lsb,rcflg);
				break;
			case 13:
				if(wherey()==15) {
					if(kycnt>0) {
						for(x=3;x>0;x--) mem[rcfrq+x-1]=0;
						inbcd(rcfrq);
					}
				}
				if(wherey()==16) {
					if(kycnt>0) {
						for(x=3;x>0;x--) mem[txfrq+x-1]=0;
						inbcd(txfrq);
					}
				}
            if(mem[txfrq]<1) {
					if(mem[txfrq+1]<(0x50)) {
						for(x=3;x>0;x--) mem[txfrq+x-1]=mem[rcfrq+x-1];
					}
				}
				cflg(chv,rcflg);
				cflg(chl,rcflg);
				comqu(work,reset,0);
		  		comqu(chnl,store,9);
				disl=0;
				gotoxy(1,22);
				printf("                                    \n");
				printf("                                                        \n");
				printf("                                     \n");
				printf("                       ");
				kycnt=0;
				gotoxy(1,20);
				delline();
				return;
			case 8:
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				}
			return;

		}
		modis2();
		return;
	}
	if(key==13) {
				mem[work]=0;
				mem[work1]=0;
      		inbcd(chnl);
				comqu(chnl,rview,1);
				menuc();
				momenu();
				for(t=1;t<8;t++) mem[chnl+t]=0;
				modis();
				gotoxy(1,22);
				printf("Use the -> and <- to change channels\n");
				printf("Use the 'UP' and 'DOWN' arrows to change cursor location\n");
				printf("Press the 'DEL' key to delete channel\n");
				printf("Press 'ENTER' when done");
				gotoxy(25,15);
				disl=4;
				keylev=5;
				kycnt=0;
				return;
				}

		if(key==8) {
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				}
				}
}
funcdd()
{
	if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Scanning Rate");
		gotoxy(1,22);
		printf("Use the 'UP' and 'DOWN' arrows to change the scan rate\n");
		printf("Press 'ENTER' when finished");
		gotoxy(24,15);
		disl=3;
		mem[work]=1;
		comqu(work,scscr,1);
		sflg(2,dsflg);
		y=0;
		return;
		}
	if(key==13) {
		disl=0;
		kycnt=0;
		cflg(2,dsflg);
		gotoxy(1,22);
		printf("                                                      \n");
		printf("                           ");
      comqu(rcfrq,reset,0);
		return;
	}
		if(key==0) {
 			switch(upkey>>8) {
				case 72:
					mem[work]=4;
					kycnt=0;
	   		   comqu(work,scscr,1);
					break;
				case 80:
					mem[work]=5;
					kycnt=0;
	   		   comqu(work,scscr,1);
					break;
			}
		}
}
funce()
{
	if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Frequency Step");
		gotoxy(1,22);
		printf("Use the 'UP' and 'DOWN' arrows to change the Frequency Step\n");
		printf("Press 'ENTER' when finished");
		gotoxy(24,15);
		disl=3;
		mem[work]=1;
		comqu(work,sfscr,1);
		sflg(2,dsflg);
		y=0;
		return;
		}
	if(key==13) {
		disl=0;
		kycnt=0;
		cflg(2,dsflg);
		gotoxy(1,22);
		printf("                                                           \n");
		printf("                           ");
      comqu(rcfrq,reset,0);
		return;
	}
		if(key==0) {
 			switch(upkey>>8) {
				case 72:
					mem[work]=4;
					kycnt=0;
	   		   comqu(work,sfscr,1);
					break;
				case 80:
					mem[work]=5;
					kycnt=0;
	   		   comqu(work,sfscr,1);
					break;
			}
		}


}
funcf()
{
	if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Enter time in the following format hr:min:sec");
		gotoxy(13,16);
		printf("  :  :\b\b\b\b\b\b");
		disl=3;
		keylev=5;
		cursoron();
		return;
		}
		if(key==8) {
			if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				if(kycnt==1) printf("\b :\b\b");
				if(kycnt==3) printf("\b :\b\b");
			}
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		kycnt++;
		printf("%d",keycd);
		if(kycnt==2) printf(":");
		if(kycnt==4) printf(":");
		keyary[kycnt]=keycd;
		return;
	}
	if(key==13) {
		mem[work]=0;
		mem[work1]=0;
		mem[work2]=0;
		if(kycnt<6){
			disl=0;
			kycnt=0;
			return;
		}
  		inbcd(work);
      comqu(work,ldclk,3);
		tmdt=0;
		disl=0;
		kycnt=0;
		return;
	}
	return;

}
funcg()
{
	if(disl==2) {
		menuc();
		gotoxy(13,15);
		printf("Enter date in the following format month-day-year");
		gotoxy(13,16);
		printf("  -  -\b\b\b\b\b\b");
		disl=3;
		keylev=5;
		cursoron();
		return;
		}
		if(key==8) {
			if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				if(kycnt==1) printf("\b -\b\b");
				if(kycnt==3) printf("\b -\b\b");
			}
		}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		kycnt++;
		printf("%d",keycd);
		if(kycnt==2) printf("-");
		if(kycnt==4) printf("-");
		keyary[kycnt]=keycd;
		return;
	}
	if(key==13) {
		mem[work]=0;
		mem[work1]=0;
		mem[work2]=0;
      inbcd(work);
		if(kycnt<6){
			disl=0;
			kycnt=0;
			return;
		}
		mem[work3]=mem[work];
		mem[work]=mem[work2];
		mem[work2]=mem[work3];
		if(mem[work]!=0){
			if(mem[work]<33){
   			if(mem[work1]!=0){
					if(mem[work1]<33){
						comqu(work,lddte,3);
				      tmdt=1;
					}
				}
			}
		}
		disl=0;
		kycnt=0;
		return;
	}
	return;
}
fun1d()
{
	if(disl==1) {
		menu1d();
        	disl=2;
		return;
		}
	switch(men[2]) {
		case 'A': funda();
		return;
		case 'B': fundb();
		return;
		}
	if(key==27) disl=0;

}
funda()
{
	if(disl==5) {
		switch(key) {
			case 0:
 			switch(upkey>>8) {
				case 72:
				mem[work]=upky;
				comqu(work,scont,1);
				return;
				case 80:
				mem[work]=dnky;
				comqu(work,scont,1);
				return;
			}
         break;
      case ' ':
      	comqu(work,fqscn,0);
			disl=0;
			kycnt=0;
			cflg(1,dsflg);
			break;
			}
      return;
		}
			menuc();
			gotoxy(13,15);
			printf("Use the up and Down arrows to change direction of scan");
			gotoxy(13,16);
			printf("Space bar to end scan");
			disl=5;
			sflg(1,dsflg);
			mem[work]=upky;
	       comqu(work,fqscn,1);
			 kycnt=0;
			 return;
 }

fundb()
{
		if(disl==2) {
			menuc();
			gotoxy(13,15);
			printf("Enter desired banks to scan ");
			disl=3;
			keylev=5;
			cursoron();
			return;
			}
	if(disl==5) {
		switch(key) {
			case 0:
 			switch(upkey>>8) {
				case 72:
				mem[work]=upky;
				comqu(work,scont,1);
				return;
				case 80:
				mem[work]=dnky;
				comqu(work,scont,1);
				return;
				}
      case ' ':
      	comqu(work,chscn,0);
			disl=0;
			kycnt=0;
			gotoxy(5,6);
			printf("          ");
			cflg(3,dsflg);
			break;

		}
		return;
	}
		if(key==13) {
				mem[work]=0;
				mem[work1]=0;
				mem[work2]=0;
      		inbcd(work);
				if(((mem[work+x-1])&0xf0)==0) mem[work+x-1]=(mem[work+x-1])|0xa0;
		       comqu(work,chscn,x);
				 menuc();
               gotoxy(13,15);
					printf("Use the Up and Down arrows to change direction of scan");
					gotoxy(13,16);
					printf("Space bar to stop scan");
				   disl=5;
					sflg(3,dsflg);
				   kycnt=0;
				   return;
					}

		if(key==8) {
				if(kycnt>0) {
				kycnt--;
				printf("\b \b");
				}
				}
	if(isdigit(key)) {
		keycd=key-48;
		if(kycnt>keylev) return;
		printf("%d",keycd);
		kycnt++;
		keyary[kycnt]=keycd;
		return;
		}
}
fun1e()
{
	comqu(work,smode,0);
	disl=0;
	return;
}
fun1f()
{
	comqu(work,tattn,0);
	disl=0;
	return;
}

fun1g()
{
		if(disl==1) {
			menuc();
			gotoxy(13,15);
			printf("Confirm Alarm Transmit Y/N");
			gotoxy(40,15);
			disl=2;
			return;
		}
		if(disl==3){
			comqu(work,emfrq,0);
			disl=0;
			kycnt=0;
			return;
		}
	printf("%c",key);
	gotoxy(40,15);
	if(key=='Y') {
		comqu(work,txemf,0);
		gotoxy(13,15);
		printf("Press any key to stop alarm ");
      disl=3;
		return;
	}
	disl=0;
	kycnt=0;
	return;

}
fun1h()
{
	 comqu(work,emfrq,0);
	disl=0;
	kycnt=0;
	return;
}
fun1i()
{
	if(disl==1) {
		menuc();
		gotoxy(13,15);
		printf("Press any key to return to normal");
		comqu(work,swtfr,0);
		disl=2;
		return;
		}
		comqu(work,swtfr,0);
		disl=0;
		return;
}
fun1j()
{
	if(disl==1) {
		menu2();
		disl=2;
		return;
		}
	switch(men[2]) {
		case 'A': fun2a();
		break;
		case 'B': fun2b();
		break;
		case 'C': fun2c();
		break;
		case 'D': fun2d();
		break;
		case 'E': fun2e();
		break;
		case 'F': fun2f();
		break;
		case 'G': fun2g();
		break;
		case 'Q': fun2q();
		break;
	}
	if(key==27) disl=0;
	if(key==13) disl=0;
}
fun2a()
{
	comqu(work,tsbfl,0);
	disl=0;
	return;
}
fun2b()
{
	comqu(work,tblnk,0);
	disl=0;
	return;
}
fun2c()
{
	tflg(sr,anmtr);
	comqu(work,pwmtr,0);
	disl=0;
	return;
}
fun2d()
{
	comqu(work,txmtp,0);
	disl=0;
	return;
}
fun2e()
{
	if(tmdt!=0) {
	comqu(work,gttme,0);
	tmdt=0;
	}
	else {
		comqu(work,gtdte,0);
		tmdt=1;
	}
	disl=0;
}
fun2f()
{
	comqu(work,tvtfl,0);
	disl=0;
}
fun2g()
{
	comqu(work,tmrgl,0);
	disl=0;
}
fun2q()
{
  	d=inportb(0x21);
	d=d|0x18;
	outportb(0x21,d);
	cursoron();
   exit();
}

opcode()
{
	switch((data[2][a])-0x80){
		case 1: opcode1();
		break;
		case 2: opcode2();
		break;
		case 3: opcode3();
		break;
		case 4: break;
		case 5: opcode5();
		break;
		case 6: opcode6();
		break;
		case 7: break;
		}
}
opcode1()
{
	for(x=3;x<=datac+1;x++) mem[(clock)+(x-3)]=data[x][a];
	distm();
}

opcode2()
{
	for(x=3;x<=datac+1;x++) mem[(chnl)+(x-3)]=data[x][a];
	modis();
}
opcode3()
{
	for(x=3;x<=datac+1;x++) mem[(work)+(x-3)]=data[x][a];
	mem[rdflg]=mem[rdflg]|mem[work];
	if(flgs(7,work)==1) {
		dsetting();
		return;
	}

	mem[rdflg]=mem[rdflg]&(~mem[work]);
	dsetting();

}
opcode5()
{
	for(x=3;x<=datac+1;x++) mem[(chnl)+(x-3)]=data[x][a];
	momenuc();
}
opcode6()
{
	m=wherex();
	n=wherey();
	for(x=3;x<=datac+1;x++) mem[(temp)+(x-3)]=data[x][a];
	x=mem[temp];
	if((x-oldmtr)==0) return;
	gotoxy(15,9);
	for(y=1;y<=x;y=y+8)	printf("*");
	for(y=x;y<=oldmtr;y=y+8) printf(" ");
	oldmtr=x;
	cflg(4,dsflg);
	gotoxy(m,n);

}

setup()
{
	cursoroff();
	for(dcount=0;dcount<5;dcount++){
	icont=0xef;
		for(lp1=1;lp1<=2;lp1++) {
			brak=0;
			ty=1;
			yc=1;
			xc=1;
			if(ready==2) break;
			ivln=13-lp1;
			prt=lp1-1;
			rxtx=((4-lp1)<<8)+0x0f8;
			inte=((4-lp1)<<8)+0x0f9;
			disc=((4-lp1)<<8)+0x0fa;
			lcon=((4-lp1)<<8)+0x0fb;
			mcon=((4-lp1)<<8)+0x0fc;
			lstt=((4-lp1)<<8)+0x0fd;
			mstt=((4-lp1)<<8)+0x0fe;
			bioscom(0,0x0e3,prt);
			install(comrx,ivln);
			outportb(inte,0x03);
			outportb(mcon,0xf);
  			d=inportb(0x21);
			d=d&icont;
			outportb(0x21,d);
			icont=0xf7;
			delay(20);
			txque[1][1]=0x11;
			txque[2][1]=0x88;
			txque[3][1]=0x88;
			send();
			dump();
		}
	if(ready==2) break;
	trigger=0;
	bcount=0;
	ready=0;
	brak=0;
	rcount=0;
	}
	if(ready!=2) {
			clrscr();
			printf("Communications not established, please check connections and try again");
			cursoron();
			exit();
	}
	comqu(work,gttme,0);
	clrscr();
	gotoxy(5,2);
	printf("Channel ");
	gotoxy(5,3);
	printf("RC Freq ");
	gotoxy(5,4);
	printf("TX Freq ");
	gotoxy(30,2);
	printf("Mode ");
	gotoxy(5,9);
	printf("    Power ");
        gotoxy(55,9);
	printf("Power setting ");
}
distm()
{
/*	struct date td;*/
/*	struct time nw;*/
/*	getdate(&td);*/
/*	gettime(&nw);*/
/*	told=nw.ti_sec;*/
/*	gotoxy(60,1);*/
/*	printf("Date %d/%d/%d",td.da_mon,td.da_day,td.da_year);*/
/*	printf("Time %02d:%02d:%02d",nw.ti_hour,nw.ti_min,nw.ti_sec);*/
	m=wherex();
	n=wherey();
	gotoxy(60,2);
	if(tmdt!=0) printf("Date %x/%x/%x   ",mem[clock+1],mem[clock],mem[clock+2]);
	else {
		inclck();
		printf("Time %02x:%02x:%02x   ",mem[clock+2],mem[clock+1],mem[clock]);
	}
	if(mem[temp]!=0) {
		m=wherex();
		n=wherey();
		gotoxy(15,9);
		for(y=0;y<=mem[temp];y=y+8) printf(" ");
		mem[temp]=0;
		gotoxy(m,n);
	}
	osec=sec;
	gotoxy(m,n);
}
dsetting()
{
	m=wherex();
	n=wherey();
	gotoxy(13,2);
	if(flgs(chv,rcflg)==0){
		if(mem[chnl+1]!=0){
			printf("%x",mem[chnl+1]);
			if((mem[chnl]&0xf0)==0) printf("0");
		}
		printf("%x    ",mem[chnl]);
	}
	else	printf("      ");
	gotoxy(13,3);
	if(mem[rcfrq+2]!=0) printf("%x",mem[rcfrq+2]);
	if((mem[rcfrq+1]+mem[rcfrq+2])!=0){
		if((mem[rcfrq+1]&0xf0)==0) printf("0");
		printf("%x",mem[rcfrq+1]);
   }
	printf("%x.%x      ",((mem[rcfrq]&0xf0)>>4),(mem[rcfrq]&0xf));
	gotoxy(13,4);
	if(mem[txfrq+2]!=0) printf("%x",mem[txfrq+2]);
	if((mem[txfrq+1]+mem[txfrq+2])!=0){
		if((mem[txfrq+1]&0xf0)==0) printf("0");
	   printf("%x",mem[txfrq+1]);
	}
	printf("%x.%x      ",((mem[txfrq]&0xf0)>>4),(mem[txfrq]&0xf));
	gotoxy(36,2);
	if(flgs(pci,rcflg)==1) {
		if(flgs(ssb,rcflg)==1) printf("CW ");
		else printf("A3J");
		}
	else {
		if(flgs(ssb,rcflg)==1) printf("A3A");
		else printf("A3H");
                }

	gotoxy(60,4);
	if(flgs(voc,rcflg)==1) printf("TLX");
	else printf("VOC");
	gotoxy(65,4);
	if(flgs(lsb,rcflg)==1) printf("LSB");
	else printf("USB");
	gotoxy(70,4);
	if(flgs(att,rcflg)==1) printf("ATT");
	else printf("   ");
	gotoxy(60,5);
	if(flgs(tn,rdflg)==1) printf("TND");
	else printf("   ");
	gotoxy(65,5);
	if(flgs(nb,rdflg)==1) printf("NB");
	else printf("   ");
	gotoxy(70,5);
	if(flgs(tmr,anmtr)==1) printf("TMR");
	else printf("   ");
	gotoxy(5,9);
	if(flgs(sr,anmtr)==1) printf("SWR");
	else printf("FWD");
        gotoxy(69,9);
	if(flgs(tpl,txflg)==1) printf("LOW ");
	else printf("HIGH");
	cflg(4,dsflg);
	gotoxy(m,n);
	}
menuc()
{
	gotoxy(1,12);
	printf("   ===========================================================================\n");
	printf("   ||                                                                       ||\n");
	printf("   ||   								    ||\n");
	printf("   ||   								    ||\n");
	printf("   ||   								    ||\n");
	printf("   ||									    ||\n");
	printf("   ||                                                                       ||\n");
	printf("   ===========================================================================\n");
	delline();
	}

menu1()
{
	gotoxy(1,12);
	printf("   ===MENU 1==================================================================\n");
	printf("   ||                                                                       ||\n");
	printf("   ||   [A] CHANGE CHANNEL			   [F] ATTENUATOR 	    ||\n");
	printf("   ||   [B] CHANGE FREQUENCY			   [G] EMERGENCY ALARM	    ||\n");
	printf("   ||   [C] PROGRAM				   [H] 2182 EMERGENCY	    ||\n");
	printf("   ||   [D] SCAN				   [I] PREVIEW TX FREQ	    ||\n");
	printf("   ||   [E] CHANGE MODE				   [J] MENU 2		    ||\n");
	printf("   ||                                                                       ||\n");
	printf("   ===========================================================================\n");
	delline();
	delline();
	delline();
	delline();
	delline();

	}
menu2()
{
	gotoxy(7,12);
	printf("MENU 2=======\n\n");
	printf("   ||   [A] USB / LSB			   	   [E] TIME / DATE	    ||\n");
	printf("   ||   [B] NOISE BLANKER			   [F] VOC / TLX	    ||\n");
	printf("   ||   [C] POWER METER MODE			   [G] TIMER		    ||\n");
	printf("   ||	[D] POWER LEVEL                            [Q] QUIT		    ||\n");
	printf("   ||                                                                       ||\n");
	printf("   ===========================================================================\n");
	printf("   Press 'ESC' to return to main menu 					      \n");
	delline();
	delline();
	delline();
	delline();
}
menu1c()
{
	gotoxy(7,12);
	printf("PROGRAM===\n\n");
	printf("   ||   [A] SCAN BANK				   [E] FREQUENCY STEP	    ||\n");
	printf("   ||   [B] TIMER				   [F] TIME		    ||\n");
	printf("   ||   [C] CHANNEL				   [G] DATE		    ||\n");
	printf("   ||	[D] SCANNING RATE						    ||\n");
	printf("   ||                                                                       ||\n");
	printf("   ||                                                                       ||\n");
}
menucb()
{
	gotoxy(7,12);
	printf("TIMER=====\n\n");
	printf("   ||   [A] SET  ON & OFF TIME						    ||\n");
	printf("   ||   [B] ON CHANNEL							    ||\n");
	printf("   ||   [C] ON FREQUENCY						    ||\n");
	printf("   ||							      		    ||\n");
}
momenu()
{
	gotoxy(1,14);
	printf("   ||   CHANNEL	                        [A] MODE                            ||\n");
	printf("   ||   RX FREQUENCY               	[B] AUDIO FILTER             	    ||\n");
	printf("   ||   TX FREQUENCY         		[C] SIDE BAND	            	    ||\n");
	printf("   ||					[D] ATTENUATOR              	    ||\n");
}
modis()
{
	m=wherex();
	n=wherey();
	gotoxy(25,14);
	if(men[3]!='C') {
	if(mem[chnl+1]!=0){
	 	printf("%x",mem[chnl+1]);
		if((mem[chnl]&0xf0)==0) printf("0");
	}
	printf("%x    ",mem[chnl]);
	}
	gotoxy(25,15);
	if(mem[rcfrq+2]!=0) printf("%x",mem[rcfrq+2]);
	if((mem[rcfrq+1]+mem[rcfrq+2])!=0){
		if((mem[rcfrq+1]&0xf0)==0) printf("0");
	 	printf("%x",mem[rcfrq+1]);
	}
	printf("%x.%x      ",((mem[rcfrq]&0xf0)>>4),(mem[rcfrq]&0xf));
	gotoxy(25,16);
	if(mem[txfrq+2]!=0) printf("%x",mem[txfrq+2]);
	if((mem[txfrq+1]+mem[txfrq+2])!=0){
		if((mem[txfrq+1]&0xf0)==0) printf("0");
    	printf("%x",mem[txfrq+1]);
	}
	printf("%x.%x      ",((mem[txfrq]&0xf0)>>4),(mem[txfrq]&0xf));
	gotoxy(65,14);
	if(flgs(pci,rcflg)==1) {
		if(flgs(ssb,rcflg)==1) printf("CW ");
		else printf("A3J");
		}
	else {
		if(flgs(ssb,rcflg)==1) printf("A3A");
		else printf("A3H");
                }
	gotoxy(65,15);
	if(flgs(voc,rcflg)==1) printf("TLX");
	else printf("VOC");
	gotoxy(65,16);
	if(flgs(lsb,rcflg)==1) printf("LSB");
	else printf("USB");
	gotoxy(65,17);
	if(flgs(att,rcflg)==1) printf("ATT");
	else printf("   ");
	gotoxy(m,n);
}
modis2()
{
	m=wherex();
	n=wherey();
	gotoxy(65,14);
	if(flgs(pci,rcflg)==1) {
		if(flgs(ssb,rcflg)==1) printf("CW ");
		else printf("A3J");
		}
	else {
		if(flgs(ssb,rcflg)==1) printf("A3A");
		else printf("A3H");
                }
	gotoxy(65,15);
	if(flgs(voc,rcflg)==1) printf("TLX");
	else printf("VOC");
	gotoxy(65,16);
	if(flgs(lsb,rcflg)==1) printf("LSB");
	else printf("USB");
	gotoxy(65,17);
	if(flgs(att,rcflg)==1) printf("ATT");
	else printf("   ");
	gotoxy(m,n);

}
momenuc()
{
	gotoxy(23,15);
	printf("#%x  ",mem[bank]);
	gotoxy(50,15);
	if(mem[chnl+1]>0){
		printf("%x",mem[chnl+1]);
		if((mem[chnl]&0xf0)==0) printf("0");
	}
	printf("%x    ",mem[chnl]);
	gotoxy(50,15);
}
mostrt()
{
	gotoxy(28,15);
	if((mem[rcfrq+1]>>4)!=0) printf("%d",(mem[rcfrq+1]>>4));
	if((mem[rcfrq+1]&0xf)!=0) printf("%d",(mem[rcfrq+1]&0xf));
	if((mem[rcfrq]>>4)!=0) printf("%d",(mem[rcfrq]>>4));
	printf("%d      ",(mem[rcfrq]&0xf));
	gotoxy(28,15);
}
scands()
{
	gotoxy(5,6);
/*	printf("Bank # %x",mem[scptr]);*/
	dsetting();
	gotoxy(1,22);
}
menu1d()
{
	gotoxy(7,12);
	printf("SCAN======\n\n");
	printf("   ||   								    ||\n");
	printf("   ||   [A] FREQUENCY							    ||\n");
	printf("   ||   [B] CHANNEL BANKS						    ||\n");
	printf("   ||   								    ||\n");
	printf("   ||									    ||\n");
}
sflg(bit,byte)
{
	y=1;
	y=y<<bit;
	mem[byte]=mem[byte]|y;
}
cflg(bit,byte)
{
	y=1;
	y=y<<bit;
	mem[byte]=mem[byte]&~y;
}
tflg(bit,byte)
{
	y=1;
	y=y<<bit;
	mem[byte]=mem[byte]^y;
}
flgs(bit,byte)
int byte;
{
	y=1;
	y=y<<bit;
	x=mem[byte]&y;
    y=x>>bit;
	return y;
}
inclck()
{
	diff=sec-osec;
	for(x=1;x<=diff;x++){
		if(((++mem[clock])&0x0f)>=10) {
			mem[clock]=((mem[clock])&0xf0)+0x10;
			if(mem[clock]>=0x60) {
				mem[clock]=0;
				if(((++mem[clock+1])&0xf)>=10) {
					mem[clock+1]=((mem[clock+1])&0xf0)+0x10;
					if(mem[clock+1]>=0x60){
						mem[clock+1]=0;
						if(((++mem[clock+2])&0xf)>=10) {
							mem[clock+2]=((mem[clock+2])&0xf0)+0x10;
							if(mem[clock+2]>=0x24) mem[clock+2]=0;
         			}
					}
				}
			}
		}
	}
}
inbcd(loc)
int loc;
{
	x=0;
	for(y=kycnt;y>0;y--) mem[loc+x++]=keyary[y]|(keyary[(y--)-1]<<4);
}
cursoron()
{
	_AH=1;
	_CH=6;
	_CL=7;
	geninterrupt(0x10);
}
cursoroff()
{
	_AH=1;
	_CH=0x20;
	_CL=0;
	geninterrupt(0x10);
}
dchar()
{
	m=wherex();
	n=wherey();
	printf(" \b");
   for(y=kycnt;y>0;y--){
		gotoxy(m-kycnt-1+y,n);
		printf(" %d",keyary[y]);
	}
	gotoxy(m,n);
}

comqu(source,op,bytes)
unsigned char	source,op,bytes;
{
	a=1;
	txque[a++][ty]=bytes+1+0x70;
	txque[a++][ty]=op;
	y=op;
	for(x=0;x<bytes;x++) {
		y=y+mem[source];
		txque[a++][ty]=mem[source++];
		}
	txque[a++][ty]=y;
	txque[a++][ty]=0;
	txque[a++][ty++]=0;
	brak=3;
}
dump()
{
	for(t=1;t<=3000;t++) {
	if(kbhit()) break;
		if(ready==1) {
			for(a=1;a<=yy;a++) {
				sumck=0;
				datac=(data[1][a]&0x0f);
				for (x=2;x<=(datac+2);x++){
					if((data[1][a]&0xf0)<0x70) break;
					sumck=sumck+data[x][a];
				}
				if(sumck!=0) {
					if((data[2][a])>0x80) opcode();
					else for(x=3;x<=datac+1;x++){
						mem[(data[2][a])+(x-3)]=data[x][a];
						sflg(4,dsflg);
					}
				}
	 		}
			if(disl<2) if(flgs(4,dsflg)==1) dsetting();
			cflg(4,dsflg);
			if(flgs(1,dsflg)==1) dsetting();
			if(flgs(2,dsflg)==1) mostrt();
			if(flgs(3,dsflg)==1) scands();
			ready=2;
			xx=0;
			yy=0;
			break;
		}
	}
	x=0;
   y=0;
}
send()
{
	if(bcount>0) return;
	a=inportb(lcon);
	a=a|0x40;
	outportb(lcon,a);
	delay(10);
	outportb(lcon,(a&0x0bf));
	delay(10);
	if(bcount>0) return;
	brak=1;
	geninterrupt(ivln);
}
install(void interrupt(*faddr)(),int inum)
{
	setvect(inum,faddr);
}
